#
# spec file for package perl-Riap
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-Riap
Version:        1.2.4
Release:        1.1
%define cpan_name Riap
Summary:        Rinci access protocol
License:        Artistic-1.0 or GPL-1.0+
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/Riap/
Source0:        http://www.cpan.org/authors/id/P/PE/PERLANCAR/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
%{perl_requires}

%description
Rinci access protocol (Riap for short), is a client/server,
request/response protocol for requesting metadata and performing actions on
code entities. It is modeled closely after HTTP, but is a different
protocol. It can be layered on top of HTTP (as its transport protocol) but
can also use other transports, including direct TCP.

The server side is viewed as being a tree of code entities, with a package
entity at the root. Other entities (such as subpackages, functions,
variables) are discoverable by performing 'list' actions on package
entities. Entity's metadata can be retrieved using the 'meta' action. There
are other actions defined in the specification; and the protocol can be
extended by introducing more actions.

One of the main use-cases of this protocol is to provide self-descriptive,
self-documenting, machine-discoverable API service, much like the goal of
SOAP and WSDL. However it is much simpler and programmer-friendly than
those protocols.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}

%check
%{__make} test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes LICENSE README

%changelog
* Fri Sep  4 2015 coolo@suse.com
- updated to 1.2.4
  see /usr/share/doc/packages/perl-Riap/Changes
  1.2.4   2015-09-04 (PERLANCAR)
  - No spec changes.
  - [dist] Move spec prereqs from RuntimeRequires to
  DevelopRecommends to reduce deps but still allow indicating spec
  requirement.
* Tue Apr 14 2015 coolo@suse.com
- updated to 1.2.3
  see /usr/share/doc/packages/perl-Riap/Changes
  1.2.3   2015-03-05 (PERLANCAR)
    [REMOVED FEATURES]
  - Remove support for "J" header in Riap::Simple. In order to further
    simplify the Riap::Simple protocol, client can now only send "j"
    header. The server now responds also using "j" header. All request and
    response are now single lines.
  1.2.2   2014-10-30 (PERLANCAR)
  - Support Rinci's partial argument/result as well as input/output stream
    (in Riap as well as Riap::HTTP, but not in Riap::Simple).
  1.2.1   2014-10-23 (PERLANCAR)
  - No spec changes.
  - Typo: unimplemented status is 501, not 502.
  1.2.0    2014-10-23 (PERLANCAR)
  - Bump version to 1.2. This version addresses sending/receiving binary
    data over JSON by base64-encoding.
  - Client can send base64-encoded binary data in arguments using the
    C<ARGNAME:base64> key in 'args' Riap request key.
  - Server can return base64-encoded binary data in result by setting
    result metadata property 'riap.result_encoding' to 'base64'.
  - Server now MUST return result metadata with at least 'riap.v' with
    the value of 1.2. The 'info' action is now not required to send Riap
    protocol version ('v').
  - Client MUST check and strip all 'riap.*' keys in result metadata.
    Client must fail when it encounters an unknown 'riap.*' key or a
    known key with an invalid/unknown value. This is so that future
    incompatibilities can be handled/detected.
  1.1.24	 2014-08-18 (SHARYANTO)
  - No spec changes.
  - Mention JSON RPC.
  1.1.23	 2014-06-18 (SHARYANTO)
    [ENHANCEMENTS]
  - Introduce new action 'complete_arg_elem'.
  1.1.22	 2013-12-21 (SHARYANTO)
    [INCOMPATIBLE CHANGES]
  - Remove 'marklog' request key, merge it into 'loglevel'. This is
    because, if separate chunks are not marked, result is mixed with log
    message(s).
  1.1.21	 2013-12-21 (SHARYANTO)
  - Introduce 'X-Riap-V' (require HTTP response header) to let server
    declare Riap::HTTP protocol version.
  - Allow server to decline 'loglevel' and 'marklog' request, by
    requiring client to read the value of 'X-Riap-Logging' HTTP response
    header. The absence of this HTTP header means server does not
    support it.
  1.1.20	 2013-11-27 (SHARYANTO)
  - list action: should return relative URIs to be more tree-like.
* Fri Sep 21 2012 coolo@suse.com
- initial package 1.1.19
  * created by cpanspec 1.78.06
